#! /usr/bin/python

# Tapioca library
# Copyright (C) 2006 INdT.
# @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br>
#	  Kenneth Christiansen <kenneth.christiansen@gmail.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import pygtk
pygtk.require("2.0")
import gtk
import gobject
import tapiocabase
import tapiocaclient
import sys
import os
import signal

## variables ##
global mainloop;
global factory;
global manager;
global parameters;
global conn_g;

def exit_program():
	conn_g.tpa_connection_disconnect()
	mainloop.quit()
	print "Disconnected. Finishing test...\n"

def main ():
	signal.signal(signal.SIGINT, exit_program);

	mainloop = gobject.MainLoop()

	tapiocabase.debug_set_flags_from_env ();

	factory = tapiocaclient.ManagerFactory();

	if not factory:
		print "failed to create Connection Manager Factory!\n"
        	sys.exit(1)

	manager = factory.get_manager("jabber")

	if not manager:
        	print "failed to create Connection Manager!\n"
		sys.exit(1)

	## setup the parameters for connection ##
	parameters = manager.get_protocol_parameters("jabber")

	account = os.environ.get("ACCOUNT")
	password = os.environ.get("PASSWORD")

	if not account:
		print "please set environment ACCOUNT!\n"
		sys.exit(1)
	else:
		print "account:%s\n" % account

	if not password:
		print "please set environment PASSWORD!\n"
 	else:
		print "password:%s\n" % "**********"

	parameters.set_value_as_string("account", account)
	parameters.set_value_as_string("password", password)
	parameters.set_value_as_string("server", "talk.google.com")
	parameters.set_value_as_string("resource", "tapioca")
	parameters.set_value_as_uint("port", 5223)
	parameters.set_value_as_boolean("old-ssl", True)
	parameters.set_value_as_boolean("ignore-ssl-errors", True)

	## Get a Connection ##
	conn_g = manager.request_connection("jabber", parameters)

	if conn_g == None:
		print "failed to create Connection!\n"
		sys.exit(1)

	## Set up connection callbacks ##
	conn_g.connect("status-changed", status_changed_cb)
	conn_g.connect("channel-created", channel_created_cb)

	## Connect! ##
	conn_g.make_connection()

	mainloop.run()

def status_changed_cb(conn, status, reason):
	print "Got state-changed signal from TpaConnection\nstatus: %d, reason: %d\n" % (status, reason)

	if status == tapiocaclient.CONNECTION_STATUS_CONNECTED:
		print "Connected!\nProtocol: %s\n" % conn.get_protocol()
		print "Status: %d\n" % conn.get_status()

		conn.get_open_channels()
		list = conn.get_contactlist()
		list.get_known()
		user = conn.get_user_contact()
		user.set_capabilities(tapiocaclient.CAPABILITY_ALL)

	if status == tapiocaclient.CONNECTION_STATUS_DISCONNECTED:
		print "Disconnected. Finnishing test...\n"
		mainloop.quit()

def channel_play_cb (data):
    tapiocaclient.stream_channel_play (data)

    return False;

def channel_created_cb(conn, channel):
	print "Got channel-created signal from TpaConnection\nchannel: %p\n" % channel

	if channel.get_channel_type() == tapiocaclient.CHANNEL_TYPE_STREAM:
		print "dd"
		g_timeout_add (10000, channel_play_cb, channel)

if __name__ == "__main__": 
	main()
