#! /usr/bin/python

# Tapioca library
# Copyright (C) 2006 INdT.
# @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br>
#         Kenneth Christiansen <kenneth.christiansen@gmail.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import pygtk
pygtk.require("2.0")
import gtk
import gobject
import tapiocabase
import tapiocaclient
import sys
import os
import signal

## variables ##
global mainloop;
global factory;
global manager;
global parameters;
global connection;
global list

def exit_program():
	# do not disconnect 
	# connection.disconnect()
	mainloop.quit()
	print "Finishing test...\n";

def main():
	signal.signal(signal.SIGINT, exit_program);

	mainloop = gobject.MainLoop()

	tapiocabase.debug_set_flags_from_env ();

	factory = tapiocaclient.ManagerFactory()

        if not factory:
                print "failed to create Connection Manager Factory!\n"
                sys.exit(1)

        manager = factory.get_manager("jabber")

        if not manager:
                print "failed to create Connection Manager!"
                sys.exit(1)

	parameters = manager.get_protocol_parameters("jabber")

        account = os.environ.get("ACCOUNT")
        password = os.environ.get("PASSWORD")

        if not account:
                print "please set environment ACCOUNT!"
                sys.exit(1)
        else:
                print "account:%s" % account

        if not password:
                print "please set environment PASSWORD!"
        else:
                print "password:%s" % "**********"

        parameters.set_value_as_string("account", account)
        parameters.set_value_as_string("password", password)
        parameters.set_value_as_string("server", "talk.google.com")
        parameters.set_value_as_string("resource", "tapioca")
        parameters.set_value_as_uint("port", 5223)
        parameters.set_value_as_boolean("old-ssl", True)
        parameters.set_value_as_boolean("ignore-ssl-errors", True)

        ## Get a Connection ##
        connection = manager.request_connection("jabber", parameters)

	if not connection:
		print "failed to create Connection!"
		exit(1);

	## Set up connection callbacks ##
	connection.connect("status-changed", status_changed_cb)

	## Connect! ##
	connection.make_connection()

	mainloop.run()

def status_changed_cb (conn, status, reason):
	print "State-changed status: %d, reason: %d\n" % (status, reason)
    
	if status == tapiocaclient.CONNECTION_STATUS_CONNECTED:
		print "Connected!\nProtocol: %s" % (conn.get_protocol())
		print "Status: %d" % (conn.get_status())

	 	conn.get_open_channels()
		user = conn.get_user_contact()
		print "Changing status to away\n"
		user.set_presence_with_message(tapiocaclient.PRESENCE_AWAY, "Away")

		list = conn.get_contactlist()
		contacts = list.get_subscribed()

		print "Contact list:"
		
		for contact in contacts:
			print "\t'%s'" % (tapiocaclient.ChannelTarget.get_uri(contact))

	if status == tapiocaclient.CONNECTION_STATUS_DISCONNECTED:
		print "Disconnected. Finnishing test...\n"
		mainloop.quit()

if __name__ == "__main__": 
        main()
